import Dropdown from '@stimulus-components/dropdown';

export default class extends Dropdown {
  static targets = ['toggleButton'];

  connect() {
    super.connect();
    if (this.element.dataset.isOpen === 'true') {
      this.toggleTransition();
    }
  }

  toggle() {
    super.toggle();

    if (this.hasToggleButtonTarget) {
      const dropdownRect = this.menuTarget.getBoundingClientRect();
      const triggerRect = this.toggleButtonTarget.getBoundingClientRect();
      const spaceBelow = window.innerHeight - triggerRect.bottom;
      const spaceAbove = triggerRect.top;

      if (spaceBelow < dropdownRect.height && spaceAbove > dropdownRect.height) {
        this.menuTarget.classList.add('pop-up');
        this.menuTarget.classList.remove('pop-down');
      } else {
        this.menuTarget.classList.add('pop-down');
        this.menuTarget.classList.remove('pop-up');
      }
    }
  }

  forceHide() {
    this.leave();
  }
}
