import { Controller } from '@hotwired/stimulus';
import { isEmailAddress } from 'helpers/emails';
import attachSlimSelectTo from 'helpers/attach_slimselect';

export default class extends Controller {
  connect() {
    this.detachCallback = attachSlimSelectTo(this.element, this.extraOptions);
  }

  disconnect() {
    this.detachCallback(this);
  }

  get extraOptions() {
    const addable = this.element.getAttribute('data-addable') == 'true';
    const addableFormat = this.element.getAttribute('data-addable-format');

    const opts = {}

    if (addable) {
      opts.events = {
        addable: (value) => {
          if (addableFormat == 'email') {
            return isEmailAddress(value) && value;
          }

          return value;
        },
      }
    }

    return opts;
  }
}
