# frozen_string_literal: true

module SpiritHub
  class UploadsController < ApplicationController
    skip_before_action :authenticate_user!
    before_action :skip_authorization, :skip_policy_scope

    def show
      @upload = Upload.find(params[:id])
      @docs = @upload.documents.to_a
      @doc_being_viewed = @docs.find { |doc| doc.id.to_s == params[:doc] } if params[:doc]
      @doc_being_viewed ||= @docs.first # rubocop:disable Naming/MemoizedInstanceVariableName
    end
  end
end
