# frozen_string_literal: true

module SpiritHub
  class TagsetFormatter
    class << self
      include ActionView::Context
      include ActionView::Helpers::TagHelper
      include ActionView::Helpers::TextHelper
      include TagsHelper

      def tagset_docs_as_shared_attachments_to_json(tagsets)
        tagsets.to_a.map { |t| { text: t.title, value: t.id.to_s, html: title_with_parent_dirs_html(t) } }
      end

      private

      def title_with_parent_dirs_html(tagset)
        tag.div(class: 'flex flex-row gap-2') do
          concat tag.span(tagset.title)
          tagset.parent_directories.each do |tagset_dir|
            concat tag_gray(tagset_dir.title)
          end
        end
      end
    end
  end
end
