# frozen_string_literal: true

module SpiritHub
  module InputsHelper
    def search_input(label:, required: false, input_params: {})
      tag.div do
        concat(tag.div(class: 'text-sm text-spirit-gray pb-2') do
          concat tag.span(label)
          concat render('spirit_hub/common/required_indicator') if required
        end)
        concat(tag.div(class: 'flex flex-row items-center px-3 py-4 gap-2 h-11 bg-white shadow-[0px_1px_3px_rgba(0,0,0,0.14)]') do
          concat tag.i(class: 'fa fa-magnifying-glass text-spirit-gray ')
          concat tag.input(type: 'text', class: 'focus:outline-none focus:ring-0 w-full', placeholder: 'Rechercher', **input_params)
        end)
      end
    end
  end
end
