# frozen_string_literal: true

Doc.class_eval do
  after_save :update_tagset_doc_doc_fields

  def self.create_from_file!(file, user)
    doc = Doc.create!(responsible: user&.id, title: file.original_filename)
    doc.blob = file.read
    doc.update!(type: 'file')
    doc.logs.create(user_id: user.id, action: 'Création du fichier', code: 'CFB') if user
    doc
  end

  def update_tagset_doc_doc_fields
    return unless %i[file_ext doc_file_size tagset_id].any? { |attr| saved_change_to_attribute?(attr) }

    Tagset.where(type: 'document', doc_ids: id).each do |tagset|
      tagset.update_docs_fields
      tagset.save if tagset.changed?
    end
  end
end
