# frozen_string_literal: true

User.class_eval do
  def display_option
    @display_option ||= SpiritHub::DisplayOption.find_or_create_by(user_id: id)
  end

  def operative_team
    Team.where(:$or => [{ :operators.in => [id.to_s] }, { :writers.in => [id.to_s] }]).first
  end

  def to_be_signed_docs
    Tagset.where(type: 'document', :accounted.in => [id.to_s], state_id: SpiritHub::HubdocCycle.find_state_by_key('to_sign')&.id)
  end

  def to_be_signed_for_me_docs
    # TODO
    []
  end

  def to_complete_docs
    Tagset.where(type: 'document', :accounted.in => [id.to_s], state_id: SpiritHub::HubdocCycle.find_state_by_key('to_complete')&.id)
  end

  def to_validate_docs
    Tagset.where(type: 'document', :accounted.in => [id.to_s], state_id: SpiritHub::HubdocCycle.find_state_by_key('to_validate')&.id)
  end

  def responses_docs
    Tagset.where(type: 'document', :accounted.in => [id.to_s], state_id: SpiritHub::HubdocCycle.find_state_by_key('to_answer')&.id)
  end

  def admin?
    has_role?('Administrator')
  end
end
