# frozen_string_literal: true

module SpiritHub
  class DisplayOptionPolicy
    attr_reader :user, :display_option

    def initialize(user, display_option)
      @user = user
      @display_option = display_option
    end

    def update_shown_columns?
      user.id == display_option.user_id
    end

    def update_view_type?
      user.id == display_option.user_id
    end

    class Scope
      attr_reader :user, :scope

      def initialize(user, scope)
        @user = user
        @scope = scope
      end

      def resolve
        scope.where(user:)
      end
    end
  end
end
