# frozen_string_literal: true

module SpiritHub
  class PhasePolicy
    attr_reader :user, :phase

    def initialize(user, phase)
      @user = user
      @phase = phase
    end

    def inline_edit?
      user.admin? || phase.operation.writers?(user) || phase.operation.responsible?(user)
    end

    def update_inline?
      inline_edit?
    end

    class Scope
      attr_reader :user, :scope

      def initialize(user, scope)
        @user = user
        @scope = scope
      end

      def resolve
        scope.all
      end
    end
  end
end
