# frozen_string_literal: true

module SpiritHub
  module TeamActivities
    class CollaboratorPolicy
      attr_reader :user, :other_user

      def initialize(user, other_user)
        @user = user
        @other_user = other_user
      end

      def index?
        user.present?
      end

      def sort?
        index?
      end

      class Scope
        attr_reader :user, :scope

        def initialize(user, scope)
          @user = user
          @scope = scope
        end

        def resolve
          scope.where(type: 'document', spirit_hubdoc: true)
        end
      end
    end
  end
end
