# frozen_string_literal: true

module SpiritHub
  class ToClassifyPolicy
    attr_reader :user, :tagset

    def initialize(user, tagset)
      @user = user
      @tagset = tagset
    end

    def index?
      user.present?
    end

    def sort?
      index?
    end

    class Scope
      attr_reader :user, :scope

      def initialize(user, scope)
        @user = user
        @scope = scope
      end

      def resolve
        scope.where(
          type: 'document',
          spirit_hubdoc: true,
          responsible: user.id,
          parent_tagset_ids: []
        )
      end
    end
  end
end
