# frozen_string_literal: true

module SpiritHub
  class TodosPolicy
    attr_reader :user, :tagset

    def initialize(user, tagset)
      @user = user
      @tagset = tagset
    end

    def index?
      user.present?
    end

    def sort?
      index?
    end

    class Scope
      attr_reader :user, :scope

      def initialize(user, scope)
        @user = user
        @scope = scope
      end

      def resolve
        scope.where(
          type: 'document',
          spirit_hubdoc: true,
          :parent_tagset_ids.ne => [],
          :percent.ne => 100,
          :accounted.in => user.accounted_ids
        )
      end
    end
  end
end
