# frozen_string_literal: true

module SpiritHub
  class FavoritesCounts
    attr_reader :user

    def initialize(user)
      @user = user
    end

    def counts
      {
        to_classify: resolve_policy_scope(user, Tagset, SpiritHub::ToClassifyPolicy::Scope).count,
        todo: resolve_policy_scope(user, Tagset, SpiritHub::TodosPolicy::Scope).count,
        shared: resolve_policy_scope(user, Tagset, SpiritHub::SharedPolicy::Scope).count
      }
    end

    private

    def resolve_policy_scope(user, scope, policy_scope_class)
      policy_scope_class.new(user, scope).resolve
    end
  end
end
