# frozen_string_literal: true

module SpiritHub
  class TagsetSuggester
    %i[suggest_spaces_to_classify].each do |method_name|
      define_singleton_method(method_name) do |tagset, user, *args, **opts|
        new(tagset, user).public_send(method_name, *args, **opts)
      end
    end

    def initialize(tagset, user)
      @tagset = tagset
      @user = user
    end

    def suggest_spaces_to_classify(limit: 5)
      suggested_spaces = @tagset.docs.to_a.flat_map { |doc| doc.suggests_for('spaces', user: @user, limit:) }
      suggested_spaces.to_a.uniq.take(limit)
    end
  end
end
