# frozen_string_literal: true

module SpiritHub
  class TagsetsGroupSuggester
    %i[suggest_spaces_to_classify].each do |method_name|
      define_singleton_method(method_name) do |tagsets, user, *args, **opts|
        new(tagsets, user).public_send(method_name, *args, **opts)
      end
    end

    def initialize(tagsets, user)
      @tagsets = tagsets
      @user = user
    end

    def suggest_spaces_to_classify(limit: 5)
      # We try to take 100 here to increase the chances of getting more suggestions that are common across all @tagsets
      suggested_spaces_from_each = @tagsets.map { |tagset| TagsetSuggester.suggest_spaces_to_classify(tagset, @user, limit: 100) }
      suggested_spaces_from_each.to_a.reduce(:&).take(limit)
    end
  end
end
