Feature: Add doc modal

  Scenario: Add one doc
    Given I am a logged in admin
    And There is some directories
    When I visit the url /spirit_hub/search?search_params%5Bcleaned_main_key%5D=
    And I click on the add doc button
    And I add one doc
    And I submit the form
    Then I should see the doc in the list

  Scenario: Add multiple docs without regrouping
    Given I am a logged in admin
    And There is some directories
    When I visit the url /spirit_hub/search?search_params%5Bcleaned_main_key%5D=
    And I click on the add doc button
    And I add multiple docs
    And I submit the form
    Then I should see the docs in the list

  Scenario: Add multiple docs with regrouping
    Given I am a logged in admin
    And There is some directories
    When I visit the url /spirit_hub/search?search_params%5Bcleaned_main_key%5D=
    And I click on the add doc button
    And I add multiple docs
    And I regroup the docs
    And I submit the form
    Then I should see the doc in the list
    And The doc is a regrouped doc

  Scenario: Add doc after adding a previous doc
    Given I am a logged in admin
    And There is some directories
    When I visit the url /spirit_hub/search?search_params%5Bcleaned_main_key%5D=
    And I click on the add doc button
    And I add multiple docs
    And I add new docs
    And I submit the form
    Then I should see all the docs in the list

  Scenario: Add multiple docs with chained action
    Given I am a logged in admin
    And There is some directories
    When I visit the url /spirit_hub/search?search_params%5Bcleaned_main_key%5D=
    And I click on the add doc button
    And I add multiple docs
    Then I cannot add a action
    When I regroup the docs
    Then I can add a action
    When I select the share action
    And I submit the form
    Then I should see the share form
    And I should see the doc in the list
    And The doc is a regrouped doc

  Scenario: Cancel regrouping doesn't trigger the action
    Given I am a logged in admin
    And There is some directories
    When I visit the url /spirit_hub/search?search_params%5Bcleaned_main_key%5D=
    And I click on the add doc button
    And I add multiple docs
    When I regroup the docs
    And I select the share action
    And I cancel the regrouping
    And I submit the form
    Then I should not see the share form
    Then I should see the docs in the list

  Scenario: Add to completeness
    Given I am a logged in admin
    And There is one directory with completeness
    When I visit the url /spirit_hub/search?search_params%5Bcleaned_main_key%5D=
    And I click on the add doc button
    And I add multiple docs
    And I select the completeness
    Then I can add a action
    When I submit the form
    Then I should see the completeness in the list
    And The doc is a regrouped doc