import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';
import '../../../support/step_definitions/modal_steps';

Given('There is a directory with some docs to validate', () => {
  let tagset_ids = [];
  cy.appFactories([['create_list', 'tagset_doc', 5, 'with_state', { state_key: 'to_validate' }]]).then(records => {
    records[0].forEach(record => {
      tagset_ids.push(record.id);
    });
  });
  cy.appFactories([['create', 'tagset_directory', 'with_journal_entries', { responsible: '1', id: '1', tagset_ids: tagset_ids }]]);
});

When('I click on the validate button', () => {
  cy.get('#model_table tbody tr:first form[action="/spirit_hub/tagsets/form/validate"] button').click();
});

When('I click on the refuse button', () => {
  cy.get('#model_table tbody tr:first form[action="/spirit_hub/tagsets/form/refuse"] button').click();
});

When('I fill the form', () => {
  cy.get('textarea[name="message"]').type('This is a message');
  cy.get('select[name="recipients[]"]').next('div').click();
  cy.contains('.ss-list:visible > .ss-option', 'Admin User (admin@test.com)').first().click({ force: true });
});

When('I submit the form', () => {
  cy.get('button[data-base-form-target="submitButton"]').click({ force: true });
  cy.waitForTurboResponse();
});
