import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';
import '../../../support/step_definitions/modal_steps';

Given('There is some docs', () => {
  cy.appFactories([['create_list', 'tagset_doc', 5, 'with_state']]);
});

Given('There is a tagset with multiple docs', () => {
  cy.appFactories([['create', 'tagset_doc', 'with_state', 'with_files', { filenames: ['pdf_sample.pdf', 'pdf_sample2.pdf'] }]]);
});

When('I click on the send {string} button', action => {
  cy.get('#model_table tbody tr:first td:last div[data-controller="better-dropdown"] button').first().click();
  cy.get(`form[action="/spirit_hub/tagsets/form/${action}"]`).first().click();
});

When('I fill the form', () => {
  cy.get('select[name="recipients[]"]').next('div').click();
  cy.contains('.ss-list:visible > .ss-option', 'Admin User (admin@test.com)').first().click({ force: true });
  cy.get('textarea[name="message"]').type('This is a message');
});

When('I fill the to sign form', () => {
  cy.get('select[name="doc_id"]').next('div').click();
  cy.contains('.ss-list:visible > .ss-option', 'pdf_sample2.pdf').first().click({ force: true });
  cy.get('select[name="recipients[]"]').next('div').click();
  cy.contains('.ss-list:visible > .ss-option', 'Admin User (admin@test.com)').first().click({ force: true });
  cy.get('textarea[name="comments"]').type('This is a message');
});

When('I submit the form', () => {
  cy.get('button[data-base-form-target="submitButton"]').click({ force: true });
  cy.waitForTurboResponse();
});
