import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';
import '../../../support/step_definitions/doc_view_steps';

let tagset_id;
let doc_id;

Given('There is one favorite doc', () => {
  cy.appFactories([['create', 'doc_favorite', 'with_file', { user_id: '1' }]]).then(records => {
    tagset_id = records[0].tagset_id;
  });
});

Given('There is one doc', () => {
  cy.appFactories([['create', 'tagset_doc', 'with_file', 'with_state', { filename: 'pdf_sample.pdf', state_key: 'to_validate' }]]).then(records => {
    doc_id = records[0].doc_ids[0];
    tagset_id = records[0].id;
  });
});

When('I click on the first doc', () => {
  cy.get('#model_table tbody tr:first td:last a:first').click();
});

When('I visit the doc page', () => {
  cy.visit(`/spirit_hub/tagsets/${tagset_id}/doc/${doc_id}`);
});

When('I validate the doc', () => {
  cy.get('form[action="/spirit_hub/tagsets/form/validate"] button').click();
  cy.get('textarea[name="message"]').type('This is a message');
  cy.get('select[name="recipients[]"]').next('div').click();
  cy.contains('.ss-list:visible > .ss-option', 'Admin User (admin@test.com)').first().click({ force: true });
  cy.get('button[data-base-form-target="submitButton"]').click({ force: true });
  cy.waitForTurboResponse();
});

Then('There is no more validation button', () => {
  cy.get('form[action="/spirit_hub/tagsets/form/validate"]').should('not.exist');
});

Then('I can toggle the button actions', () => {
  cy.get('button[title="Actions"]').click();
  cy.contains('Autres actions');
});

Then('I can click on other actions menu', () => {
  cy.get('button[title="Autres actions"]').click();
  cy.contains('Classer');
});
