import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

// Right colums
Given('There is one tagset to classify with all columns', () => {
  cy.appFactories([['create', 'operation', { id: 'operation1', title: 'Operation 1' }]]);
  cy.appFactories([['create', 'tagset_doc', 'with_informed', 'with_file', 'with_state', { responsible: '1', tagset_ids: [], operation_id: 'operation1' }]]);
});

Then('I should see the right columns', () => {
  cy.get('#model_table td').eq(3).contains('Doc Title 1');
  cy.get('#model_table td').eq(4).contains('Operation 1');
  cy.get('#model_table td').eq(5).contains('7.1 Ko');
  cy.get('#model_table td').eq(6).contains(new Date().toLocaleDateString('fr-FR'));
  cy.get('#model_table td').eq(7).find('div').should('exist');
  cy.get('#model_table td').eq(8).find('img').should('exist');
  cy.get('#model_table td').eq(9).contains('Classé');
  cy.get('#model_table td').eq(10).find('a').should('exist');
});

Given('There is some search docs', () => {
  cy.appFactories([['create_list', 'tagset_doc', 5, { responsible: '1', tagset_ids: [] }]]);
});

Given('There is a lot of search docs', () => {
  cy.appFactories([['create_list', 'tagset_doc', 20, { responsible: '1', tagset_ids: [] }]]);
});

// I can search
Given('There is some tagset and docs to search', () => {
  cy.appFactories([['create', 'operation', { id: 'operation1', title: 'Operation 1' }]]);
  cy.appFactories([['create', 'operation', { id: 'operation2', title: 'Operation 2' }]]);

  cy.appFactories([['create_list', 'tagset_directory', 3, { operation_id: 'operation1' }]]);
  cy.appFactories([['create_list', 'tagset_directory', 2, { operation_id: 'operation2' }]]);
  cy.appFactories([['create_list', 'tagset_directory', 1, {}]]);

  cy.appFactories([['create_list', 'tagset_doc', 3, { operation_id: 'operation1' }]]);
  cy.appFactories([['create_list', 'tagset_doc', 2, { operation_id: 'operation2' }]]);
  cy.appFactories([['create_list', 'tagset_doc', 1, {}]]);
});

When('I can search', () => {
  cy.get('input[name="search_params[cleaned_main_key]"]').first().type('1{enter}');
  cy.get('#model_table tbody tr:visible').should('have.length', 2);

  cy.get('input[name="search_params[cleaned_main_key]"]').first().clear().type('{enter}');
  cy.get('#model_table tbody tr:visible').should('have.length', 12);

  cy.get('#search_params_operation_id').next('div').click();
  cy.get('.ss-list > div:visible').eq(1).click();
  cy.get('#filter_search_form').submit();
  cy.get('#model_table tbody tr:visible').should('have.length', 6);

  cy.get('#search_params_type').next('div').click();
  cy.get('.ss-list > div:visible').eq(1).click();
  cy.get('#filter_search_form').submit();
  cy.get('#model_table tbody tr:visible').should('have.length', 3);

  cy.get('input[name="search_params[cleaned_main_key]"]').first().clear().type('{enter}');
  cy.wait(500);
  cy.get('#search_params_current_state').next('div').click();
  cy.get('.ss-list > div').contains('À classer').click();
  cy.get('#filter_search_form').submit();
  cy.get('#model_table tbody tr:visible').should('have.length', 6);
});

Given('There is a doc to validate on the search page', () => {
  cy.appFactories([['create', 'tagset_doc', 'with_state', { state_key: 'to_validate' }]]);
});
