import { Given, When, Then } from '@badeball/cypress-cucumber-preprocessor';

Given('There is one tagset to classify with all columns', () => {
  cy.appFactories([['create', 'operation', { id: 'operation1', title: 'Operation 1' }]]);
  cy.appFactories([['create', 'tagset_doc', 'with_informed', 'with_file', 'with_state', { responsible: '1', tagset_ids: [], state_key: 'share', operation_id: 'operation1' }]]);
});

Then('I should see the right columns', () => {
  cy.get('#model_table td').eq(3).contains('Doc Title 1');
  cy.get('#model_table td').eq(4).contains('Operation 1');
  cy.get('#model_table td').eq(5).contains('7.1 Ko');
  cy.get('#model_table td').eq(6).contains(new Date().toLocaleDateString('fr-FR'));
  cy.get('#model_table td').eq(7).find('div').should('exist');
  cy.get('#model_table td').eq(8).find('img').should('exist');
  cy.get('#model_table td').eq(9).contains('Partagé');
  cy.get('#model_table td').eq(10).find('a').should('exist');
});

Given('There is some shared docs', () => {
  cy.appFactories([['create_list', 'user', 3]]).then(records => {
    const user_ids = records[0].map(record => record.id);

    cy.appFactories([['create_list', 'tagset_doc', 5, 'with_state', { responsible: '1', informed: user_ids, state_key: 'share' }]]);
  });
});

Given('There is a lot of shared docs', () => {
  cy.appFactories([['create_list', 'user', 3]]).then(records => {
    const user_ids = records[0].map(record => record.id);
    cy.appFactories([['create_list', 'tagset_doc', 20, 'with_state', { responsible: '1', informed: user_ids, state_key: 'share' }]]);
  });
});

Given('There is some tagset directories', () => {
  cy.appFactories([['create_list', 'tagset_directory', 5]]);
});

Given('There is a doc to validate on the shared page', () => {
  cy.appFactories([['create', 'tagset_doc', 'with_state', 'with_informed', { state_key: 'to_validate', accounted: ['1'] }]]);
});
