# frozen_string_literal: true

require 'rails_helper'

RSpec.describe(Doc, type: :model) do
  before do
    SpiritHub::HubdocCycle.import_cycle_from_json
  end

  describe 'update_tagset_doc_doc_fields' do
    let!(:tagset) { create(:tagset_doc, :with_file) }
    let!(:doc) { tagset.doc }

    it 'updates tagset doc fields' do
      expect(tagset.reload.file_ext).to eq(doc.file_ext)
      expect(tagset.reload.doc_file_size).to eq(doc.file_size)

      doc.update(file_ext: 'jpeg', file_size: 1000)

      expect(tagset.reload.file_ext).to eq('jpeg')
      expect(tagset.reload.doc_file_size).to eq(1000)
    end
  end
end
